<template>
  <Base activeIndex="2" @getuser="setuser" :avatar="UserProfileImg">
  </Base>
  <div class="UserInfo">
    <el-row :gutter="20">
      <el-col :span="24">
        <el-main class="main">
          <el-row :gutter="20">
            <el-col :span="3"> </el-col>
            <el-col :span="4">
            </el-col>
            <el-col :span="6">
              <el-select v-model="value2" filterable class="m-2" placeholder="Select" size="large"
                :filter-method="remoteMethod">
                <el-option v-for="item in options_activities_time" :key="item.value" :label="item.label"
                  :value="item.value" />
              </el-select>
            </el-col>
            <el-row span="3"> </el-row>

            <el-button type="success" size="large" @click="serchMethod">查询 </el-button>
            <el-col :span="3">
              <el-button type="success" size="large" style="color:white;" @click="issue"
                v-if="author != 3">
                发布活动</el-button>
            </el-col>

          </el-row>

          <el-space direction="vertical" alignment="start" :size="30">
            <br />

            <el-space wrap :size="size" v-if="isSearchActivity">
              <el-card v-for="i in activityInfo.activities" :key="i" class="box-card"
                style="width: 340px; height: 270px">
                <template #header>
                  <div class="card-header" style="text-align: left">
                    <span>活动名称</span>
                    <el-button type="danger" style="position:relative;left:180px;" v-if="this.author != 3"
                      @click="del(i.id)">删除</el-button>
                  </div>
                </template>
                <div style="text-align:left">名称: {{ i.topic }}</div><br />
                <div style="text-align:left">分值: {{ i.score }}</div><br />
                <div style="text-align:left">活动日期: {{ i.startTime }}~{{ i.endTime }}</div><br />
                <div>
                  <el-button class="button" type="primary" @click="feedback(i.id)" v-if="i.state != -1"
                  :disabled="i.state!=0">上传反馈</el-button>
                  <el-button type="danger" @click="modify(i.id)" v-if="this.author != 3">修改</el-button>
                  <el-button class="button" type="primary" @click="lookup(i.id)">查看详情</el-button>
                </div>
              </el-card>
            </el-space>
          </el-space>
        </el-main>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { ref } from "vue";
import global from "./Common.vue"
import Base from "./Base.vue"
import axios from 'axios'

export default {
  name: "UserInfo",
  data() {
    return {
      activityInfo: {
        activities: [
          {
            college: null,
            content: "yk我爱你！！！...",
            endTime: "Sun, 01 May 2022 19:30:00 GMT",
            id: 3,
            startTime: "Sun, 01 May 2022 18:00:00 GMT",
            topic: "test",
          },
          {
            college: null,
            content: "yk我爱你！！！！...",
            endTime: "Sun, 01 May 2022 19:30:00 GMT",
            id: 4,
            startTime: "Sun, 01 May 2022 18:00:00 GMT",
            topic: "test",
          },
        ],
        code: "00",
        msg: "获取全部活动成功",
        paginate: {
          page: 2,
          pages: 3,
          total: 5,
        },
        user:"",
      },

      isSearchActivity: true,
      item: {
        date: "2016-05-02",
        name: "Tom",
        address: "No. 189, Grove St, Los Angeles",
      },

      value: ref(""),

      value2: ref(""),
      tableData: [],
      options_activities_form: [
        {
          value: "具体信息",
          label: "具体信息",
        },
        {
          value: "简要信息",
          label: "简要信息",
        },
      ],

      options_activities_time: [
        {
          value: "全部",
          label: "全部",
        },
        {
          value: "即将到来的",
          label: "即将到来的",
        },
        {
          value: "审核通过的",
          label: "审核通过的",
        },
        {
          value: "正在审核的",
          label: "正在审核的",
        },
        {
          value: "全部完成的",
          label: "全部完成的",
        },
      ],
      user: {
        permission: ""
      },
      ip: global.ip,
      page: 1,
      per_page: 20,
      activity_status_type: 0,
      UserProfileImg: "",
      author: ''
    };
  },
  computed: {
    aveScore() {
      var sum = 0;
      var cnt = 0;
      this.comments.forEach((item) => {
        cnt = cnt + 1;
        sum = sum + item.score;
      });
      return sum / cnt;
    },
  },
  methods: {
    searchActivity() {
      this.isSearchActivity = true;
    },
    lookup(id) {
      window.location.replace("http://" + global.ip_front + "/activity?id=" + id);
    },
    feedback(id) {
      window.location.replace("http://" + global.ip_front + "/activity_feedback?feedback_id=" + id)
    },
    modify(id) {
      window.location.replace("http://" + global.ip_front + "/activities_modify?id=" + id
      );
    },
    del(id) {
      let token = localStorage.getItem('token');
      axios({
        method: "POST",
        data: {
          activity_id: id
        },
        url: "http://" + this.ip + "/api/manage/deleteactivity",
        headers: { 'Authorization': `Bearer: ${token}` }
      }).then((res) => {
        console.log(res)
        if (res.data.code == '00'){
          console.log("删除成功")
          alert("删除成功！")
        }
      })
    },
    issue() {
      window.location.replace("http://" + global.ip_front + "/activities_issue")
    },
    setuser(user) {
      let token = localStorage.getItem('token');
      this.user.permission = user.permission;
      axios({
        method: 'POST',
        url: "http://" + this.ip + "/api/user/role",
        data: {
          author: this.user.permission
        },
        headers: { Authorization: `Bearer: ${token}` }
        
      })
      console.log("8848")
    },
    serchMethod() {
      
      let status_type = 0;
      if(this.value2 == '即将到来的')
        status_type = 1;
      else if(this.value2 == '审核通过的')
        status_type = 2;
      else if(this.value2 == '正在审核的')
        status_type = 3;
      else if(this.value2 == '全部已经完成的')
        status_type = 4;
      axios({
        method: 'POST',
        url: "http://" + this.ip + "/api/browse/all",
        data: {
          page: this.page,
          per_page: this.per_page,
          activity_status_type: this.activity_status_type,
          activity_status_type:status_type
        },
        headers: { Authorization: `Bearer: ${token}` }
      }).then((res) => {
        console.log(res);
        if (res.data.code == '00') {
          this.activityInfo.activities = res.data.activities;
        }
      });
    }
  },
  created() {
    let token = localStorage.getItem('token');
    const author = localStorage.getItem('author')
    this.author = author
    axios({
      method: 'POST',
      url: "http://" + this.ip + "/api/browse/all",
      data: {
        page: this.page,
        per_page: this.per_page,
        activity_status_type: this.activity_status_type,
      },
      headers: { Authorization: `Bearer: ${token}` }
    }).then((res) => {
      console.log(res);
      if (res.data.code == '00') {
        this.activityInfo.activities = res.data.activities;
      }
    });
    // 请求用户头像
    axios({
      method: "POST",
      url: "http://" + this.ip + "/api/user/avatar",
      data: {

      },
      responseType: 'blob',
      headers: { Authorization: `Bearer: ${token}` }
    }).then((res) => {
      console.log(res.data)
      this.UserProfileImg = window.URL.createObjectURL(res.data);
      console.log(this.UserProfileImg)
    });
    // 请求用户权限
    axios({
      method: "POST",
      url: "http://" + this.ip + "/api/user/profile",
      data: {

      },
      headers: { Authorization: `Bearer: ${token}` }
    }).then((res) => {
      console.log(res.data)
      this.user.permission = res.data.author
    });
  },
  components: {
    Base
  }
};
</script>


<style scoped>
a {
  text-decoration: none;
  color: white;
}

.layout-container-demo .el-header {
  position: relative;
  background-color: var(--el-color-primary-light-7);
  color: var(--el-text-color-primary);
}

.layout-container-demo .el-aside {
  color: var(--el-text-color-primary);
  background: var(--el-color-primary-light-8);
}

.layout-container-demo .el-menu {
  border-right: none;
}

.layout-container-demo .el-main {
  padding: 0;
}

.layout-container-demo .toolbar {
  display: inline-flex;
  align-items: center;
  justify-content: center;
  height: 100%;
  right: 20px;
}

.font_1 {
  text-align: center;
  font-size: 25px;
}

.scrollbar-demo-item {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 50px;
  margin: 10px;
  text-align: center;
  border-radius: 4px;
  background: var(--el-color-primary-light-9);
  color: var(--el-color-primary);
}
</style>

<style scoped>
.activity_list_item {
  height: 30px;
  margin: 10px 20px 20px 20px;
  background: #69f61291;
  text-align: center;
}

.el-col {
  border-radius: 4px;
}

.bg-purple-dark {
  background: #99a9bf;
}

.bg-purple {
  background: #d3dce6;
}

.bg-purple-light {
  background: #e5e9f2;
}

.grid-content {
  border-radius: 4px;
  min-height: 36px;
}

.UserInfo {
  background: rgb(238, 241, 246);
}

.topHeader {
  background-color: #f8f8f8;
  color: #123456;
  line-height: 60px;
  margin-bottom: 1px;
}

.sideBar {
  background: #fff;
  margin-right: 10px;
  text-align: left;
}

.courseBasic {
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  margin: 10px 20px 20px 20px;
  background: #fff;
  border-radius: 12px;
}

.main {
  position: relative;
  top: 50px;
  margin-left: 30px;
  margin-right: 30px;
  background: #fff;
  border-radius: 12px;
}

.tongjiIcon {
  color: #1c98ce;
  font-size: 20px;
  font-weight: bold;
  text-align: left;
}

.UserProfileImg {
  margin: 60px 20px 0px 100px;
  height: 200px;
  width: 200px;
  float: left;
}

.basicInfo {
  background: #f8f8f8;
  padding: 10px;
  border-radius: 8px;
  width: 300px;
}

.basicInfoType {
  margin: 10px 0px 10px 10px;
  font-size: 14px;
}

.userName {
  margin-top: 50px;
  margin-bottom: 20px;
  font-size: 24px;
  font-weight: bold;
}

.activityMessage {
  background: rgb(223, 255, 230);
  margin: 20px 30px 20px 30px;
  padding: 2px 3px 2px 30px;
  border-radius: 8px;
  text-align: center;
}

.profile {
  margin-top: 30px;
  border-radius: 100px;
  width: 50px;
  height: 50px;
}

.el-rate__icon {
  font-size: 28px;
}
</style>
